/* funcion recuperar_lista */
/* recupera los datos de una lista guardada anteriomente en un fichero
binario */
/* es de tipo void no devuelve nada */
/* recibe un puntero doble **l a la estructura rally que es la lista
donde se guardan los datos*/
/* y un puntero a caracter *fichero , que recoge el nombre del
fichero binario en donde se encuantran los datos a introducir en la lista */

#include "listas.h"

void recuperar_lista(struct rally **l,char *fichero)
{
FILE *f;
struct rally leido;
char opc='1';
int borrar=0;
if(vacia(*l)==NO)
        {
        do
                {
                printf("\nDesea conservar los datos actuales (S/N)? ");
                opc=toupper(getchar());
                fflush(stdin);
                switch(opc)
                        {
                        case 'S': printf("\nNo se ha abierto la lista.\n");
                                  break;
                        case 'N': borrar=1;
                                  break;
                        default: printf("\nOpcion incorrecta...\n\n");
                        }
                }while(opc!='N' && opc!='S');
        }
else
        borrar=2;
if(borrar==1 || borrar==2)
        {
	if(borrar==1)
        	liberar_memoria_recursivo(l);
        f=fopen(fichero,"rb");
        if(f==NULL)
                {
                printf("\nEl fichero es incorrecto.\n");
                }
        else
                {
                while(fread(&leido,sizeof(struct rally),1,f)==1)
                        insertar_al_final(l,leido);
                printf("\nLa clasificacin ha sido recuperada.\n");
                }
        fclose(f);
        }
pulsartecla();
}
