#include "cabecera.h"

main()
{
  int opc;
  int opc2;
  char respuesta;
  char f_cliente[10];
  char f_factura[10];
  char f_equipo[10];

  	 /***** Pedimos los nombres de los ficheros ******/
  system("clear");
  intr_cadena(f_cliente,"Nombre del fichero de clientes");
  intr_cadena(f_factura,"Nombre del fichero de facturas");
  intr_cadena(f_equipo,"Nombre del fichero de equipos");

  do       /************ Mens encadenados ************/
  {
      opc=menu();
      switch(opc)
      {
  	case 1:	do  /** clientes **/
  	       	{
  		    opc2=menu_clientes();             		
  		    switch(opc2)
  		    {
   		       case 1:anadir_cliente(f_cliente);
   		              break;
  		       case 2:eliminar_cliente(f_cliente);
  		              break;
  	               case 3:modificar_cliente(f_cliente);
  	                      break;
  	               case 4:lista_cliente(f_cliente);
  	               	      break;
  	               case 5:listar_clientes(f_cliente);
  	                      break;
  	               case 6:break;
                       default :f_error(-3);
  		    }
  		
  		}while(opc2!=6);
  		break;

  	case 2: do  /** equipos **/
  		{
  		    opc2=menu_equipos();              		
  		    switch(opc2)
  		    {
  		       case 1:anadir_equipo(f_equipo);
  		              break;
  		       case 2:eliminar_n_equipos(f_equipo);
  		              break;
  	               case 3:modificar_equipo(f_equipo);
  	                      break;
  	               case 4:listar_equipos(f_equipo);
  	               	      break;
  	               case 5:lista_equipo_por_codigo(f_equipo);
  	                      break;  	
  	               case 6:break;
                       default: f_error(-3);
  		    }
  		
  		}while(opc2!=6);
  		break;

  	case 3:do    /** facturas **/
  		{
  		    opc2=menu_facturas();             		
  		    switch(opc2)
  		    {
  		       case 1:anadir_factura(f_cliente,f_equipo,f_factura);
  		       	      break;
  		       case 2:eliminar_factura_numero(f_factura,f_equipo);
  		       	      break;
  	               case 3:eliminar_factura_cliente(f_factura,f_equipo,f_cliente);
  	                      break;/*eliminar por dni*/
  	               case 4:modificar_factura(f_factura,f_equipo);
  	               	      break;/*modif facturas*/
  	               case 5:listar_fichero_facturas(f_factura);
  	                      break;
  		       case 6:listar_facturas_cliente(f_factura,f_cliente);
  		              break;
                       case 7:break;
  		       default :f_error(-3);
  		    }
  		
  		}while(opc2!=7);
  		break;
  	
  	case 4:break;          	
  	default :f_error(-3);
      }

  }while(opc!=4);

  system("clear");

}/*fin main */

/**************************************************************************
   Funcin:          pausa()

   Descripcin:      Para la ejecucion del programa e imprime un aviso
                                 		                      	***/
void pausa()
{
	printf("\n\n\tPulse Intro para continuar...");
	getchar();getchar();
}
/**************************************************************************
   Funcin:          intr_cadena

   Descripcin:      evita la introduccion de una cadena vacia.

   parametros recibidos: char * cadena_a_llenar --> recibira el contenido
   			 char * campo --> cadena con el nombre de la variable
   			  	                        	**********/
void intr_cadena(char *cadena_a_llenar,char *campo)
{       	
	do
	{
		printf("\n\n\tIntroduzca %s :",campo);
		fflush(stdin);
		gets(cadena_a_llenar);       		
		
        }while(!strcmp(cadena_a_llenar,"\0")||!isalnum(cadena_a_llenar[0]));
}
/**************************************************************************
   Funcin:          intr_entero

   Descripcin:      evita la introduccion de un numero negativo

   parametro recibidos: char * campo --> cadena con el nombre de la variable
   			int * cantidad-->recibira el contenido
				                        	**********/
void intr_entero(int *cantidad,char *campo)
{
	do
	{
		printf("\n\n\tIntroduzca %s :",campo);
		scanf("%d",cantidad);
		fflush(stdin);   /*se supone que en unix funcionara*/
		if(isdigit(*cantidad))
			*cantidad=-4;
				
        }while(*cantidad<0);
}
/**************************************************************************
   Funcin:          intr_float

   Descripcin:      evita la introduccion de un numero negativo

   parametro recibidos: char * campo --> cadena con el nombre de la variable
   			float* cantidad-->recibira el contenido **********/
void intr_float(float *cantidad,char *campo)
{
	do
	{
		fflush(stdin);
		printf("\n\n\tIntroduzca %s :",campo);
		fflush(stdin);
		scanf("%f",cantidad);
		fflush(stdin);
		
        }while(*cantidad<0);
}
/**************************************************************************
   Funcin:          f_error

   Descripcin:      Gestiona los diferentes mensajes de error

   parametro recibidos: int clave -->  clave para la gestion del error
   			int respuesta--> 0,1 verdadero,falso  	**********/
int f_error(int clave)
{
        int respuesta=1;

        system("clear");
	switch(clave)
	{
	        case -1:printf("\n\n\tEl codigo introducido no existe");
	        	respuesta=0;
        		pausa();
	        	break;	 	                          	        	
	 	case -2:printf("\n\n\tError : equipos en stock insuficientes ");
	 		respuesta=0;
			pausa();
		 	break;                                    		 	
	        case -3:printf("\n\n\tOpcion incorrecta");
  			pausa();
  			break;
	        case -4:printf("\n\n\tNo existe el nif introducido");
	        	respuesta=0;
	        	pausa();
	        	break;       	        	
	        case -5:printf("\n\n\tExiste un registro con ese nif");
	        	pausa();   /*se diferencia del anterior en que la funcion*/
	        	break;     /*devolvera un 1 en este caso*/      	
	        case -6:printf("\n\n\tNo existe fichero con ese nombre.");
                        printf("\n\tCreandose...");
                        pausa();
                        break;                                             	
         	case - 7:printf("\n\n\tNo existe factura ");
         		respuesta=0;
                        pausa();
                        break;
                case -8:printf("\n\n\tEse codigo ya existe");
                        pausa();
                        break;
	}
	return(respuesta);
}