#include "principal.h"
/* Metodos de ordenacion */


/* Funcin SeleccionDirecta */
/* es de tipo void no devuelve nada, ordena alfabeticamente por apellido1,
con el metodo de seleccion directa. */
/* recibe un puntero a estructura datos_persona. *datos, que es el vector que
contiene los datos de las personas y el entero n el numero de elementos del vector*/

void SeleccionDirecta(struct datos_persona *datos,int n)
{
int i,k,menor;
struct datos_persona aux;
for(i=0;i<n-1;i++)
	{
	menor=i;
	for(k=i+1;k<n;k++)
	    {
		/* comparo el elemento de la posicion k, el apellido primero */
                if(strcmp(datos[k].apellido1,datos[menor].apellido1)<0)
		    {
		    		menor=k;
		    }
                else
		    {
                        if(strcmp(datos[k].apellido1,datos[menor].apellido1)==0)
			    {
                                if(strcmp(datos[k].apellido2,datos[menor].apellido2)<0)
					{
                                        menor=k;
					}
			    }
		    }
	    }
	aux=datos[menor];
	datos[menor]=datos[i];
	datos[i]=aux;
	}
Listar(datos,n);
}

/* Funcin OrdenarEdadShell */
/* es de tipo void y no devuelve nada. 
/* Ordena las edades de las personas de la lista por el metodo de shell. */
/* recibe como parametros un puntero *datos a la estructura datos_persona que
contiene la informacion de las personas de la lista y un entero n que es el
numero de personas del vector */

void OrdenarEdadShell(struct datos_persona *datos,int n)
{
int d,bandera,i;
struct datos_persona aux;
d=n;
do
	{
	d=d/2;
	do
		{
		bandera=0;
		i=0;
		do
			{
                        if(datos[i].edad<datos[i+d].edad)
				{
				aux=datos[i];
				datos[i]=datos[i+d];
				datos[i+d]=aux;
				bandera=1;
				}
			i++;
			}while((i+d)<n);
		}while(bandera!=0);
	}while(d!=1);
Listar(datos,n);
}		


/* funcion OrdenarEstaturaQuickSort */
/* es de tipo void no devuelve nada, realiza la ordenacion de personas de menor
a mayor estatura por el metodo quicksort ( este metodo es realmente eficiente
para muchos elementos en el vector)*/
/* recibe un puntero *datos a estructura datos_persona que son los datos de las
personas, dos enteros inferior y superior que son el limite inferior y superior
del conjunto de elementos del vector */

void OrdenarEstaturaQuickSort(struct datos_persona *datos,int inferior,int superior)
{
int i,j,mitad,error;
struct datos_persona auxiliar;
if(datos!=NULL)
	{
	i=inferior;
	j=superior;
	mitad=datos[(i+j)/2].estatura;
 	do
	    {
	    	while(datos[i].estatura>mitad)
	    		i++;
    	
	    	while(datos[j].estatura<mitad)
    		        j--;  	

	       if(i<=j)
               {
	        	auxiliar=datos[i];
        		datos[i]=datos[j];
        		datos[j]=auxiliar;
	        	i++;
        		j--;
	       }

	    }while(i<j); /* es esta la condicion si se pone <= no funciona
			    correctamente */

	    if(inferior<j)
        	  OrdenarEstaturaQuickSort(datos,inferior,j);
 	    if(superior>i)
	          OrdenarEstaturaQuickSort(datos,i,superior);
	}
}


