/* funcion principal */
/* programa de mantenimiento de la clasificacion del rally */
/* Jose Mariscal Prieto */

#include "listas.h"

main()
{
struct rally *lista,piloto;
struct nombre *nombres;
int numero,control,opc,hh,mm,ss,repetir;
char nombre[40],marca[30],seguir;

/* Inicializacin de la lista */
crear(&lista);
crear_nombres(&nombres);

do
{
/* Muestra el men de opciones y recoge la opcin */
opc=menu();

/* Llamada a las funciones segn la opcin escogida */
switch(opc)
        {
        case 1: /* Insertar al principio de la lista un participante */
                system("clear");
                printf("INSERTAR AL PRINCIPIO DE LA LISTA UN PARTICIPANTE\n");
                printf("------------------------------------------------------------------------\n");
                do
		{
			repetir=0;
			printf("\nNombre del piloto: ");
                	scanf("%s",&piloto.piloto);
                	printf("Marca del coche: ");
                	scanf("%s",&piloto.marca);
                	printf("Modelo del coche: ");
			scanf("%s",&piloto.modelo);
                	printf("Tiempo (hh mm ss): ");
                	scanf("%d %d %d",&hh,&mm,&ss);
                	fflush(stdin);
                	piloto.tiempo=conversion(hh,mm,ss);
                	insertar_al_principio(&lista,piloto);
			do
			{
				printf("\nDesea seguir introduciendo pilotos (S/N)? ");
				seguir=toupper(getchar());
				fflush(stdin);
				if(seguir=='S')
					repetir=1;
			}while(seguir!='S' && seguir!='N');
		}while(repetir==1);
                break;
        case 2: /* Insertar al final de la lista un participante */
                system("clear");
                printf("INSERTAR AL FINAL DE LA LISTA UN PARTICIPANTE\n");
                printf("------------------------------------------------------------------------\n");
		do
		{
			repetir=0;               
			printf("\nNombre del piloto: ");
                	scanf("%s",&piloto.piloto);
                	printf("Marca del coche: ");
			scanf("%s",&piloto.marca);
                	printf("Modelo del coche: ");
			scanf("%s",&piloto.modelo);
                	printf("Tiempo (hh mm ss): ");
                	scanf("%d %d %d",&hh,&mm,&ss);
                	fflush(stdin);
                	piloto.tiempo=conversion(hh,mm,ss);
                	insertar_al_final(&lista,piloto);
			do
			{
				printf("\nDesea seguir introduciendo pilotos (S/N)? ");
				seguir=toupper(getchar());
				fflush(stdin);
				if(seguir=='S')
					repetir=1;
			}while(seguir!='S' && seguir!='N');
		}while(repetir==1);
                break;
        case 3: /* Insertar de menor a mayor segn tiempo toal */
                system("clear");
		printf("INSERTAR DE MAYOR A MENOR SEGUN EL TIEMPO TOTAL\n");
		printf("---------------------------------------------------------------------\n");
		do
		{
                	repetir=0;
			printf("\nNombre del piloto: ");
                	scanf("%s",&piloto.piloto);
                	printf("Marca del coche: ");
			scanf("%s",&piloto.marca);
                	printf("Modelo del coche: ");
			scanf("%s",&piloto.modelo);
                	printf("Tiempo (hh mm ss): ");
                	scanf("%d %d %d",&hh,&mm,&ss);
                	fflush(stdin);
                	piloto.tiempo=conversion(hh,mm,ss);
                	insertar_tiempo_total(&lista,piloto);
			do
			{
				printf("\nDesea seguir introduciendo pilotos (S/N)? ");
				seguir=toupper(getchar());
				fflush(stdin);
				if(seguir=='S')
					repetir=1;
			}while(seguir!='S' && seguir!='N');
		}while(repetir==1);
                break;
        case 4: /* Insertar un piloto por orden alfabtico */
        	system("clear");
        	printf("INSERTAR UN PILOTO POR ORDEN ALFABETICO\n");
        	printf("------------------------------------------------------------------------\n");
        	do
		{
                	repetir=0;
			printf("\nNombre del piloto: ");
			scanf("%s",&piloto.piloto);
                	printf("Marca del coche: ");
			scanf("%s",&piloto.marca);
                	printf("Modelo del coche: ");
			scanf("%s",&piloto.modelo);
                	printf("Tiempo (hh mm ss): ");
                	scanf("%d %d %d",&hh,&mm,&ss);
                	fflush(stdin);
                	piloto.tiempo=conversion(hh,mm,ss);
                	insertar_por_piloto(&lista,piloto);
			do
			{
				printf("\nDesea seguir introduciendo pilotos (S/N)? ");
				seguir=toupper(getchar());
				fflush(stdin);
				if(seguir=='S')
					repetir=1;
			}while(seguir!='S' && seguir!='N');
		}while(repetir==1);
                break;
        case 5: /* Buscar a un piloto */
                system("clear");
                printf("BUSCAR A UN PILOTO\n");
                printf("-------------------------------------------------------\n\n");
                printf("Introduce el nombre del piloto: ");
                scanf("%s",&nombre);
                buscar_por_piloto(lista,nombre);
                break;
        case 6: /* Borrar a un piloto */
                system("clear");
                printf("BORRAR A UN PILOTO\n");
                printf("-------------------------------------------------------\n\n");
                printf("Introduce el nombre del piloto: ");
		scanf("%s",&nombre);
                borrar_por_piloto(&lista,nombre);
                break;
        case 7: /* Visualizar los pilotos del rally */
                visualizar_piloto(lista);
                break;
	case 8: /* Visualizar los datos de la cabeza a la cola */
		system("clear");
		printf("VISUALIZAR LOS DATOS DE LA CABEZA A LA COLA\n");
		printf("-------------------------------------------------------\n");
		control=visualizar_cabeza_cola(lista);
		if(control==1)
			printf("\nNo hay ms pilotos en la clasificacin.\n");
		else
			printf("\nNo hay ningn piloto en la clasificacin.\n");
		pulsartecla();
		break;
	case 9: /* Visualizar los datos de la cola a la cabeza */
		system("clear");
		printf("VISUALIZAR LOS DATOS DE LA COLA A LA CABEZA\n");
		printf("-------------------------------------------------------\n");
		control=visualizar_cola_cabeza(lista);
		if(control==1)
			printf("\nNo hay ms pilotos en la clasificacin.\n");
		else
			printf("\nNo hay ningn piloto en la clasificacin.\n");
		pulsartecla();
		break;
        case 10: /* Borrar toda la lista */
                 liberar_memoria(&lista);
                 printf("\nTodos los pilotos han sido borrados de la clasificacin.\n");
                 pulsartecla();
                 break;
        case 11: /* Borrar toda la lista recursivamente */
                 liberar_memoria_recursivo(&lista);
                 printf("\nTodos los pilotos han sido borrados de la clasificacin.\n");
                 pulsartecla();
                 break;
	case 12: /* Descalificaciones de los pilotos */
		 system("clear");
		 printf("DESCALIFICACIONES DE LOS PILOTOS\n");
		 printf("---------------------------------------------------------------\n\n");
		 if(vacia(lista)==SI)
			{
			printf("La clasificacin actual se encuentra vaca.\n");
			pulsartecla();
			break;
			}
		 do
			{
		 	printf("1. Borrar pilotos por nombre\n");
		 	printf("2. Borrar pilotos por tiempo\n");
		 	printf("3. Ambas opciones\n\n");
		 	printf("Elige una opcin: ");
		 	scanf("%d",&control);
		 	fflush(stdin);
		 	if(control==1 || control==3)
				{
				liberar_memoria_nombres(&nombres);
				do
					{
					printf("\nPiloto (0 para terminar): ");
					scanf("%s",&nombre);
			        	if(strcmp(nombre,"0")!=0)
						{
						insertar_al_final_nombres(&nombres,nombre);
						}
					}while(strcmp(nombre,"0")!=0);
				}
			if(control==2 || control==3)
				{
				printf("\nTiempo total mximo (hh mm ss): ");
				scanf("%d %d %d",&hh,&mm,&ss);
				fflush(stdin);
				piloto.tiempo=conversion(hh,mm,ss);
				}
			else
				piloto.tiempo=-1;
			if(control!=1 && control!=2 && control!=3)
				{
				printf("Opcin incorrecta.");
				pulsartecla();
				}
			}while(control!=1 && control!=2 && control!=3);
		 descalificaciones(&lista,nombres,piloto.tiempo);
		 break;
        case 13: /* Visualizar todos los pilotos de una determinada marca */
                 system("clear");
                 printf("VISUALIZAR TODOS LOS PILOTOS DE UNA DETERMINADA MARCA\n");
                 printf("---------------------------------------------------------------\n\n");
                 printf("Introduce la marca del coche: ");
                 scanf("%s",&marca);
		 /* gets(marca); */ /* Solaris */
                 visualizar_marca(lista,marca);
                 break;
        case 14: /* Penalizar a un piloto */
                 system("clear");
                 printf("PENALIZAR A UN PILOTO\n");
                 printf("---------------------------------------------------------------\n\n");
                 printf("Nombre del piloto a penalizar: ");
                 scanf("%s",&piloto.piloto);
                 printf("Tiempo con el que se penaliza (hh mm ss): ");
                 scanf("%d %d %d",&hh,&mm,&ss);
                 fflush(stdin);
                 piloto.tiempo=conversion(hh,mm,ss);
                 printf("\n");
		 penalizaciones(&lista,piloto);
                 break;
        case 15: /* Grabar la lista a un fichero binario */
                 system("clear");
                 printf("GRABAR LA LISTA A UN FICHERO BINARIO\n");
                 printf("---------------------------------------------------------------\n\n");
                 printf("Introduce el nombre del fichero binario: ");
                 scanf("%s",&nombre);
                 grabar_lista(lista,nombre);
                 printf("\nLa lista ha sido grabada al fichero %s.\n",nombre);
                 pulsartecla();
                 break;
        case 16: /* Recuperar la lista de un fichero binario */
                 system("clear");
                 printf("RECUPERAR LA LISTA DE UN FICHERO BINARIO\n");
                 printf("---------------------------------------------------------------\n\n");
                 printf("Introduce el nombre del fichero binario: ");
                 scanf("%s",&nombre);
                 recuperar_lista(&lista,nombre);
                 break;
        case 0: /* Salir del programa */
                 system("clear");
		 printf("Rally.c - Prctica 11 - Programada por Jose Mariscal\n");
                 printf("-----------------------------------------------------------------\n\n");
		 exit(0);
        }
}while(opc!=18);
}
