#include <stdio.h>
#include <string.h>
#include <ctype.h>
 /* Characters */

/*#define COD "codigo"*/

typedef struct
{
	int codigo;
	char nombre[15];
	char procesador[10];
	int  memoria;
	int stock;
	float precio;
	
}equipo;

typedef struct 
{
	char nombre[20];
	char apellido1[20];
	char apellido2[20];
	char  nif[12];
	char direccion[30];

}cliente;

typedef struct 
{
	int numero_fac;
	cliente reg_cliente;
	char fecha[15];
	equipo  reg_equipo;
	int descuento;
	float importe;

}factura;
			
			/*** fichero ent_sal.c ****/
int menu();
int menu_clientes();
int menu_equipos();
int menu_facturas();
int menu_modificar_equipo();
int menu_listar();
int menu_modificar_cliente();
int menu_modificar_factura();
void abrir_fichero(FILE **,char *,char *);
void sacar_pantalla_equipo(equipo );
void sacar_pantalla_cliente(cliente);
void sacar_pantalla_factura(factura);
equipo lee_equipo_teclado(int);
cliente lee_cliente_teclado(char *);

                      /*** fichero principal.c ****/

void pausa();
void intr_cadena(char *,char *); /* getsss */
void intr_entero(int *,char*);
void intr_float(float *,char *);
int f_error(int);
		
		/**** fichero equipos.c ******/

equipo busca_equipo(FILE *,int);
void anadir_equipo(char *f_equipo);
void listar_equipos(char *);
void lista_equipo_por_codigo(char *);
void modificar_equipo(char *);
void eliminar_n_equipos(char *); 
void borrar_equipo(FILE **,int,char *);
void actualiza_stock(char *,int,int);

       		/**** fichero clientes.c ******/

cliente busca_cliente(FILE *,char *);
void lista_cliente(char *);   
void listar_clientes(char *);
void anadir_cliente(char *); 
void modificar_cliente(char *);
void eliminar_cliente(char *);
void borrar_cliente(FILE **,char *,char *);

       		
       		/**** fichero facturas.c ******/
       		
void anadir_factura(char *,char *,char *);
void listar_fichero_facturas(char *);
factura busca_factura_numero(FILE *,int);
factura busca_factura_dni(FILE * ,char *);
void listar_facturas_cliente(char *,char *);
void borrar_factura(FILE **,int,char *);
void eliminar_factura_numero(char *,char*);
void actualiza_stock(char *,int,int);
void eliminar_factura_cliente(char *,char *,char*);
void modificar_factura(char *,char*);