#include "principal.h"

/* Funcion AlmacenarDatos */
/* Es de tipo entero almacena en un fichero binario los datos de las personas
contenidos en el vector. Devuelve 1 si todo ha ido correctamente y si no -1. */
/* Recibe un puntero *datos a la estructura datos_persona y un entero n que es
el numero de elementos del vector */

int AlmacenarDatos(struct datos_persona *datos,int n)
{
FILE *f;
struct datos_persona aux;
int i=0,bandera=0;
char fichero[15];
system("clear");
printf("VOLCADO DE LOS DATOS EN UN FICHERO BINARIO\n");
printf("-------------------------------------------------------------------------\n\n");
printf("Introduce el nombre del fichero al que volcar los datos: ");
scanf("%s",&fichero);
f=fopen(fichero,"wb");
while(i<n)
	{
	fwrite(&datos[i],sizeof(struct datos_persona),1,f);
	i++;
	}
i=0;
fclose(f);
f=fopen(fichero,"rb");
while(fread(&aux,sizeof(struct datos_persona),1,f)==1)
	{
	if(strcmp(aux.nombre,datos[i].nombre)!=0 || strcmp(aux.apellido1,datos[i].apellido1)!=0 || strcmp(aux.apellido2,datos[i].apellido2)!=0 || aux.edad!=datos[i].edad || aux.peso!=datos[i].peso || aux.estatura!=datos[i].estatura)
		{
		fclose(f);
		return -1;
		}
	i++;
	}
fclose(f);
return 1;
}

/* Funcion LeerFichero */
/* Recoge los registros de las personas de un fichero binario
y reserva memoria para ellos. Devuelve el numero de registros si no hay
errores en la lectura, -1 si ocurre algun error en la reserva de memoria
y -2 si ocurre un error en la lectura del fichero. */
/* Recibe un puntero doble a estructura **datos de datos_persona y un puntero
a caracter que el nombre del fichero binario*/

int LeerFichero(struct datos_persona **datos,char *fichero)
{
FILE *f;
int longitud,error,i=0;
f=fopen(fichero,"rb");
if(f==NULL)
	{
	fclose(f);
	return -2;
	}
fseek(f,0l,SEEK_END);		/* lleva el puntero f al final del fichero */
longitud=ftell(f);		/* lee el nmero de bytes que hay hasta donde esta f */
rewind(f);
longitud=longitud/sizeof(struct datos_persona);
error=Reserva(datos,longitud);
do
	{
	fread(*datos+i,sizeof(struct datos_persona),1,f);
	i++;
	}while(i<=longitud);
fclose(f);
return longitud;
}
